﻿Imports Infragistics.Win.UltraWinGrid
Imports Infragistics.Win

Public Class Form1

    Dim dtMain As New DataTable
    Private vlStatus As ValueList


    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        For Each row As UltraGridRow In UltraGrid1.Selected.Rows
            If row.Cells IsNot Nothing Then
                ' Move the row to the other group
                row.Cells("Status").Value = (CInt(row.Cells("Status").Value) + 1) Mod 3
                row.Cells("Status2").Value = row.Cells("Status").Value
                ' Update the datetime
                row.Cells("Last Updated").Value = Now
                row.RefreshSortPosition() ' **** THIS SHOULD MOVE TO THE CORRECT GROUP, BUT IT DOES NOT (most of the time) ****
            End If
        Next

    End Sub


    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        dtMain.Columns.Add("Status", GetType(Integer))
        dtMain.Columns.Add("Status2", GetType(Integer)) ' Status2 is just a copy of Status so we can see in the grid also
        dtMain.Columns.Add("ID", GetType(Integer))        
        dtMain.Columns.Add("Last Updated", GetType(DateTime))              

        ' Create some data
        For i As Integer = 0 To 2
            For j As Integer = 0 To 7
                dtMain.Rows.Add(i, i, 8 * i + j, Now)
            Next
        Next

        UltraGrid1.DataSource = dtMain

        With UltraGrid1.DisplayLayout.Bands(0)
            .Override.CellClickAction = CellClickAction.RowSelect
            .Columns("Status").ValueList = vlStatus
            .Columns("Status").SortComparer = New ValueSortComparer
            .Columns("Status2").ValueList = vlStatus
            .Columns("Status2").SortComparer = New ValueSortComparer
            .Columns("Last Updated").Format = "dd/MM/yyyy HH:mm:ss"
            ' Group by Status, sort by last updated
            .SortedColumns.Add("Status", False, True)
            .SortedColumns.Add("Last Updated", True)
        End With

    End Sub


    Private Sub UltraGrid1_InitializeLayout(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs) Handles UltraGrid1.InitializeLayout

        If vlStatus Is Nothing Then
            vlStatus = e.Layout.ValueLists.Add("Status")
            vlStatus.DisplayStyle = ValueListDisplayStyle.DisplayText

            vlStatus.ValueListItems.Add(0, "Zero")
            vlStatus.ValueListItems.Add(1, "One")
            vlStatus.ValueListItems.Add(2, "Two")
        End If

    End Sub


    Private Class ValueSortComparer
        Implements IComparer

        Public Function Compare(ByVal x As Object, ByVal y As Object) As Integer Implements System.Collections.IComparer.Compare            
            Return CShort(CType(x, UltraGridCell).Value).CompareTo(CShort(CType(y, UltraGridCell).Value))
        End Function
    End Class


End Class
